## mingw-w64-viskores-1.0.0-3.src.tar.zst

=== CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================

cmake_minimum_required(VERSION 3.15 FATAL_ERROR)
project (Viskores)

# We only allow c++14
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# When using C++14 support make sure you use the standard C++ extensions rather
# than compiler-specific versions of the extensions (to preserve portability).
set(CMAKE_CXX_EXTENSIONS OFF)

# Update module path
set(Viskores_CMAKE_MODULE_PATH ${Viskores_SOURCE_DIR}/CMake)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${Viskores_CMAKE_MODULE_PATH})

# While disabled system-wide, Viskores uses UNITY builds in some modules
set(CMAKE_UNITY_BUILD OFF)

# By default effectively disable unity builds
if (NOT DEFINED CMAKE_UNITY_BUILD_BATCH_SIZE)
  set(CMAKE_UNITY_BUILD_BATCH_SIZE 1)
endif()

# Determine Viskores version
include(Utilities/Git/Git.cmake)
include(ViskoresDetermineVersion)

# Load hardcoded version in case this is not a Git repository
file(STRINGS version.txt version_txt)
extract_version_components("${version_txt}" "Viskores")
# Get the version from git if we can
determine_version(${Viskores_SOURCE_DIR} ${GIT_EXECUTABLE} "Viskores")

if (NOT DEFINED Viskores_INSTALL_INCLUDE_DIR)
  set(Viskores_INSTALL_INCLUDE_DIR "include/viskores-${Viskores_VERSION_MAJOR}.${Viskores_VERSION_MINOR}")
endif()
if (NOT DEFINED Viskores_INSTALL_CONFIG_DIR)
  set(Viskores_INSTALL_CONFIG_DIR "lib/cmake/viskores-${Viskores_VERSION_MAJOR}.${Viskores_VERSION_MINOR}")
endif()
if (NOT DEFINED Viskores_INSTALL_LIB_DIR)
  set(Viskores_INSTALL_LIB_DIR "lib")
endif()
if (NOT DEFINED Viskores_INSTALL_BIN_DIR)
  set(Viskores_INSTALL_BIN_DIR "bin")
endif()
if (NOT DEFINED Viskores_INSTALL_SHARE_DIR)
  set(Viskores_INSTALL_SHARE_DIR "share/viskores-${Viskores_VERSION_MAJOR}.${Viskores_VERSION_MINOR}")
endif()
if (NOT DEFINED Viskores_INSTALL_CMAKE_MODULE_DIR)
  set(Viskores_INSTALL_CMAKE_MODULE_DIR "${Viskores_INSTALL_SHARE_DIR}/cmake")
endif()
if (NOT DEFINED Viskores_BUILD_CMAKE_BASE_DIR)
  set(Viskores_BUILD_CMAKE_BASE_DIR "${Viskores_BINARY_DIR}")
endif()
if(NOT DEFINED Viskores_EXECUTABLE_OUTPUT_PATH)
  ## Set the directory where the binaries will be stored
  set(Viskores_EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
endif()
if(NOT DEFINED Viskores_LIBRARY_OUTPUT_PATH)
  ## Set the directory where the libraries will be stored
  set(Viskores_LIBRARY_OUTPUT_PATH  ${PROJECT_BINARY_DIR}/lib)
endif()
if (NOT DEFINED Viskores_EXPORT_NAME)
  set(Viskores_EXPORT_NAME "ViskoresTargets")
endif()

set(Viskores_BINARY_INCLUDE_DIR "${Viskores_BINARY_DIR}/include")

#-----------------------------------------------------------------------------
# viskores_option(variable doc [initial])
#   Provides an option if it is not already defined.
# This can be replaced when CMake 3.13 is our cmake_minimum_required
macro (viskores_option variable)
  if (NOT DEFINED "${variable}")
    option("${variable}" ${ARGN})
  endif ()
endmacro ()

# Configurable Options
viskores_option(Viskores_ENABLE_CUDA "Enable Cuda support" OFF)
viskores_option(Viskores_ENABLE_KOKKOS "Enable Kokkos support" OFF)
viskores_option(Viskores_ENABLE_OPENMP "Enable OpenMP support" OFF)
viskores_option(Viskores_ENABLE_TBB "Enable TBB support" OFF)
viskores_option(Viskores_ENABLE_RENDERING "Enable rendering library" ON)
viskores_option(Viskores_ENABLE_BENCHMARKS "Enable Viskores Benchmarking" OFF)
viskores_option(Viskores_ENABLE_MPI "Enable MPI support" OFF)
viskores_option(Viskores_ENABLE_DOCUMENTATION "Build Doxygen documentation" OFF)
viskores_option(Viskores_ENABLE_EXAMPLES "Build examples" OFF)
viskores_option(Viskores_ENABLE_TUTORIALS "Build tutorials" OFF)
if (NOT DEFINED Viskores_ENABLE_TESTING)
    if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
      viskores_option(Viskores_ENABLE_TESTING "Enable Viskores Testing" ON)
    else()
      viskores_option(Viskores_ENABLE_TESTING "Enable Viskores Testing" OFF)
    endif()
endif()

# By default: (Viskores_ENABLE_TESTING OR Viskores_ENABLE_BENCHMARKS) -> Viskores_ENABLE_TESTING_LIBRARY
include(CMakeDependentOption)
cmake_dependent_option(Viskores_ENABLE_TESTING_LIBRARY "Enable Viskores Testing Library"
  OFF "NOT Viskores_ENABLE_TESTING;NOT Viskores_ENABLE_BENCHMARKS" ON)
mark_as_advanced(Viskores_ENABLE_TESTING_LIBRARY)

# The ANARI interop library uses a bit of code in viskores_rendering, so this option
# currently requires viskores_rendering to be built. Eventually this dependency
# should go away as viskores_anari doesn't require applications to use anything from
# viskores_rendering directly.
cmake_dependent_option(Viskores_ENABLE_ANARI "Enable ANARI interop support"
  OFF "Viskores_ENABLE_RENDERING" OFF)

# If you are building Doxygen, you also have the option to build the User's Guide with Sphinx
cmake_dependent_option(Viskores_ENABLE_USERS_GUIDE
  "Build User's Guide with Sphinx"
  ON
  "Viskores_ENABLE_DOCUMENTATION"
  OFF
  )
# If you are building the User's Guide, you may only need the XML output from Doxygen, which
# is much faster than generating the HTML. Thus, give the option to turn on/off the HTML output.
cmake_dependent_option(Viskores_Doxygen_HTML_output
  "Build HTML output"
  ON
  "Viskores_ENABLE_USERS_GUIDE"
  ON
  )
mark_as_advanced(Viskores_Doxygen_HTML_output)

# We may want to make finer controls on whether libraries/modules get built.
# VTK uses the concept of groups for its modules
viskores_option(Viskores_BUILD_ALL_LIBRARIES
  "Build all libraries by default. (Can be overridden for each library.)"
  ON
  )
mark_as_advanced(Viskores_BUILD_ALL_LIBRARIES)

viskores_option(Viskores_USE_DOUBLE_PRECISION "Use double precision for floating point calculations" OFF)
viskores_option(Viskores_USE_64BIT_IDS "Use 64-bit indices." ON)

viskores_option(Viskores_ENABLE_HDF5_IO "Enable HDF5 support" OFF)
if (Viskores_ENABLE_HDF5_IO)
  find_package(HDF5 REQUIRED COMPONENTS HL)
endif()

# If the linked HDF5 is parallel, we need to add the MPI include directory
# for its dependencies
viskores_option(Viskores_HDF5_IS_PARALLEL "HDF5 library is parallel" OFF)
mark_as_advanced(Viskores_HDF5_IS_PARALLEL)

# Viskores will turn on logging by default, but will set the default
# logging level to WARN.  This option should not be visible by default
# in the GUI, as ERROR and WARN level logging should not interfere
# with the performance of viskores
viskores_option(Viskores_ENABLE_LOGGING "Enable Viskores Logging" ON)

# When Viskores is embedded into larger projects they may desire to turn off
# Viskores internal assert checks when in debug mode to improve debug runtime
# performance.
viskores_option(Viskores_NO_ASSERT "Disable assertions in debugging builds." OFF)

# The CUDA compiler (as of CUDA 11) takes a surprising long time to compile
# kernels with assert in them. By default we turn off asserts when compiling
# for CUDA devices.
viskores_option(Viskores_NO_ASSERT_CUDA "Disable assertions for CUDA devices." ON)

# The HIP compiler (as of ROCm 3.7) takes a surprising long time to compile
# kernels with assert in them they generate `printf` calls which are very
# slow ( cause massive register spillage). By default we turn off asserts when
# compiling for HIP devices.
viskores_option(Viskores_NO_ASSERT_HIP "Disable assertions for HIP devices." ON)

# When Viskores is embedded into larger projects that wish to make end user
# applications they want to only install libraries and don't want CMake/headers
# installed.
viskores_option(Viskores_INSTALL_ONLY_LIBRARIES "install only viskores libraries and no headers" OFF)

# Install examples projects
cmake_dependent_option(Viskores_INSTALL_EXAMPLES "Install examples" OFF "NOT Viskores_ENABLE_EXAMPLES" ON)

# Viskores is setup by default not to export symbols unless explicitly stated.
# We prefer to only export symbols of a small set of user facing classes,
# rather than exporting all symbols. This flag is added so that consumers
# which require static builds can force all symbols on, which is something
# VTK does.
viskores_option(Viskores_HIDE_PRIVATE_SYMBOLS "Hide symbols from libraries." ON)

viskores_option(BUILD_SHARED_LIBS "Build Viskores with shared libraries" ON)
set(Viskores_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

# This flag can be used to prevent Viskores from exporting its warning flags in its
# build interface. This is useful when building Viskores as a thirdparty library
# and the warnings are too strict for the parent project.
viskores_option(Viskores_ENABLE_DEVELOPER_FLAGS "Enable compiler flags that are useful while developing Viskores" ON)

# By default Viskores would install its README.md and LICENSE.md.
# Some application might need not to install those, hence this option.
viskores_option(Viskores_NO_INSTALL_README_LICENSE "disable the installation of README and LICENSE files" OFF)

# In Python wheels, having SONAME suffixes just ends up duplicating files.
# Allow VTK to turn off these symlinks for its wheel distribution.
viskores_option(Viskores_SKIP_LIBRARY_VERSIONS "Skip versioning Viskores libraries" OFF)

# During development, running unit tests with the default values can be too lengthy.
# Allow for the developer to skip the majority of the default values and control them
# through ctest's command-line. Doesn't affect CI unless enabled.
viskores_option(Viskores_OVERRIDE_CTEST_TIMEOUT "Disable default ctest timeout" OFF)

# Viskores_ENABLE_GPU_MPI makes Viskores to use DIY routines that enables GPU aware
# MPI. By default, this option is disabled. Also, this option is hidden unless
# Viskores_ENABLE_MPI=ON.
cmake_dependent_option(Viskores_ENABLE_GPU_MPI "Enable GPU AWARE MPI support" OFF "Viskores_ENABLE_MPI" OFF)

mark_as_advanced(
  Viskores_ENABLE_LOGGING
  Viskores_NO_ASSERT
  Viskores_NO_ASSERT_CUDA
  Viskores_NO_ASSERT_HIP
  Viskores_INSTALL_ONLY_LIBRARIES
  Viskores_HIDE_PRIVATE_SYMBOLS
  Viskores_ENABLE_DEVELOPER_FLAGS
  Viskores_NO_INSTALL_README_LICENSE
  Viskores_SKIP_LIBRARY_VERSIONS
  Viskores_OVERRIDE_CTEST_TIMEOUT
  )

#-----------------------------------------------------------------------------
# Force building of modules where specified by user-facing options.
include(ViskoresModules)
viskores_module_force_group(Core VALUE "YES" REASON "Core modules always built")
viskores_module_force_group(Rendering ENABLE_OPTION Viskores_ENABLE_RENDERING)
viskores_module_force_group(Logging ENABLE_OPTION Viskores_ENABLE_LOGGING)
viskores_module_force_group(Testing
  ENABLE_OPTION Viskores_ENABLE_TESTING_LIBRARY
  ENABLE_VALUE "WANT"
  DISABLE_VALUE "DONT_WANT"
  )
viskores_module_force_group(Benchmarking ENABLE_OPTION Viskores_ENABLE_BENCHMARKS)
viskores_module_force_group(ANARI ENABLE_OPTION Viskores_ENABLE_ANARI)

# The tutorial requires several common filters. This logic might need to
# become more complicated (or less compliated if we decide to always
# compile these).
if(Viskores_ENABLE_TUTORIALS)
  viskores_module_force_group(FiltersCommon VALUE "YES" REASON "Tutorial needs common filters.")
endif()

#-----------------------------------------------------------------------------

# Setup default build types
include(ViskoresBuildType)

# Include the viskores wrappers
include(ViskoresWrappers)

=== benchmarking/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================

if(NOT viskores_module_current STREQUAL "benchmarking")
  message(FATAL_ERROR "Benchmarking CMakeLists.txt not loaded by benchmarking module.")
endif()

#Find Google Benchmark.Note that benchmark_DIR must be pointed at an
#installation, not a build directory.
find_package(benchmark REQUIRED)

function(add_benchmark exe_name)
  add_executable(${exe_name} ${exe_name}.cxx)
  target_link_libraries(${exe_name} PRIVATE benchmark::benchmark)
  viskores_module_get_property(depends benchmarking DEPENDS)
  target_link_libraries(${exe_name} PRIVATE ${depends})
  viskores_module_get_property(optional_depends benchmarking OPTIONAL_DEPENDS)
  foreach(dep IN LISTS optional_depends)
    if(TARGET ${dep})
      target_link_libraries(${exe_name} PRIVATE ${dep})
    endif()
  endforeach()
  viskores_add_drop_unused_function_flags(${exe_name})
  viskores_add_target_information(${exe_name})

  set_target_properties(${exe_name} PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${Viskores_EXECUTABLE_OUTPUT_PATH}
    CXX_VISIBILITY_PRESET "hidden"
    CUDA_VISIBILITY_PRESET "hidden"
  )

  # At some point, we might not want to compile benchmarks with device compilers.
  viskores_add_target_information(${exe_name} DEVICE_SOURCES ${exe_name}.cxx)
endfunction()

set(benchmarks
  BenchmarkArrayTransfer
  BenchmarkAtomicArray
  BenchmarkCopySpeeds
  BenchmarkDeviceAdapter
  BenchmarkFieldAlgorithms
  BenchmarkFilters
  BenchmarkLocators
  BenchmarkODEIntegrators
  BenchmarkTopologyAlgorithms
  )

if(TARGET viskores_rendering)
  list(APPEND benchmarks
    BenchmarkRayTracing
    BenchmarkInSitu
    )
endif()

set(Viskores_BENCHS_RANGE_LOWER_BOUNDARY 4096 CACHE STRING "Smallest sample for input size bench for BenchmarkDeviceAdapter")
set(Viskores_BENCHS_RANGE_UPPER_BOUNDARY 134217728 CACHE STRING "Biggest sample for input size bench for BenchmarkDeviceAdapter")
mark_as_advanced(Viskores_BENCHS_RANGE_LOWER_BOUNDARY Viskores_BENCHS_RANGE_UPPER_BOUNDARY)

foreach (benchmark ${benchmarks})
  add_benchmark(${benchmark})
endforeach ()

target_compile_definitions(BenchmarkDeviceAdapter PUBLIC Viskores_BENCHS_RANGE_LOWER_BOUNDARY=${Viskores_BENCHS_RANGE_LOWER_BOUNDARY})
target_compile_definitions(BenchmarkDeviceAdapter PUBLIC Viskores_BENCHS_RANGE_UPPER_BOUNDARY=${Viskores_BENCHS_RANGE_UPPER_BOUNDARY})

if(Viskores_ENABLE_PERFORMANCE_TESTING)
  include("${Viskores_SOURCE_DIR}/CMake/testing/ViskoresPerformanceTest.cmake")
  add_benchmark_test(BenchmarkFilters
    NAME BenchThreshold
    REGEX BenchThreshold
    )
  add_benchmark_test(BenchmarkFilters
    NAME BenchTetrahedralize
    REGEX BenchTetrahedralize
    )
  add_benchmark_test(BenchmarkFilters
    NAME BenchContourStructured
    REGEX
      BenchContour/IsStructuredDataSet:1/NIsoVals:12/MergePts:1/GenNormals:0.*/MultiPartitioned:0
      BenchContour/IsStructuredDataSet:1/NIsoVals:12/MergePts:0/GenNormals:1/FastNormals:1.*/MultiPartitioned:0
    )
  add_benchmark_test(BenchmarkFilters
    NAME BenchContourUnstructured
    REGEX
      BenchContour/IsStructuredDataSet:0/NIsoVals:12/MergePts:1/GenNormals:0.*/MultiPartitioned:0
      BenchContour/IsStructuredDataSet:0/NIsoVals:12/MergePts:0/GenNormals:1/FastNormals:1.*/MultiPartitioned:0
    )
  add_benchmark_test(BenchmarkFilters
    NAME BenchContourPartitioned
    ARGS --wavelet-dim=32 --num-partitions=128
    REGEX
      BenchContour/IsStructuredDataSet:1/NIsoVals:12/MergePts:1/GenNormals:0.*/MultiPartitioned:1
      BenchContour/IsStructuredDataSet:1/NIsoVals:12/MergePts:0/GenNormals:1/FastNormals:1.*/MultiPartitioned:1
      BenchContour/IsStructuredDataSet:0/NIsoVals:12/MergePts:1/GenNormals:0.*/MultiPartitioned:1
      BenchContour/IsStructuredDataSet:0/NIsoVals:12/MergePts:0/GenNormals:1/FastNormals:1.*/MultiPartitioned:1
    )
  add_benchmark_test(BenchmarkFilters
    NAME BenchVertexClustering
    REGEX BenchVertexClustering/NumDivs:256
    )
  if(TARGET viskores_rendering)
    add_benchmark_test(BenchmarkInSitu REGEX "BenchContour")
  endif()
endif()

=== Utilities/CI/requirements.txt ===
PyYAML
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

=== examples/clipping/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(Clipping CXX)

#Find the Viskores package
find_package(Viskores REQUIRED QUIET)

if(TARGET viskores::filter_contour AND TARGET viskores::io)
  add_executable(Clipping Clipping.cxx)
  target_link_libraries(Clipping PRIVATE viskores::filter_contour viskores::io)
endif()

=== examples/contour_tree_distributed/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================

## Copyright (c) 2018, The Regents of the University of California, through
## Lawrence Berkeley National Laboratory (subject to receipt of any required approvals
## from the U.S. Dept. of Energy).  All rights reserved.
##
## Redistribution and use in source and binary forms, with or without modification,
## are permitted provided that the following conditions are met:
##
## (1) Redistributions of source code must retain the above copyright notice, this
##     list of conditions and the following disclaimer.
##
## (2) Redistributions in binary form must reproduce the above copyright notice,
##     this list of conditions and the following disclaimer in the documentation
##     and/or other materials provided with the distribution.
##
## (3) Neither the name of the University of California, Lawrence Berkeley National
##     Laboratory, U.S. Dept. of Energy nor the names of its contributors may be
##     used to endorse or promote products derived from this software without
##     specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
## ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
## WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
## IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
## INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
## BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
## LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
## OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
## OF THE POSSIBILITY OF SUCH DAMAGE.
##
##=============================================================================
##
##  This code is an extension of the algorithm presented in the paper:
##  Parallel Peak Pruning for Scalable SMP Contour Tree Computation.
##  Hamish Carr, Gunther Weber, Christopher Sewell, and James Ahrens.
##  Proceedings of the IEEE Symposium on Large Data Analysis and Visualization
##  (LDAV), October 2016, Baltimore, Maryland.
##
##  The PPP2 algorithm and software were jointly developed by
##  Hamish Carr (University of Leeds), Gunther H. Weber (LBNL), and
##  Oliver Ruebel (LBNL)
##==============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)

# Find the Viskores package
find_package(Viskores REQUIRED QUIET)

####################################
# MPI
####################################
if (Viskores_ENABLE_MPI AND TARGET viskores::filter_scalar_topology AND TARGET viskores::io)
  add_executable(ContourTree_Distributed ContourTreeApp.cxx ContourTreeAppDataIO.h)
  target_link_libraries(ContourTree_Distributed viskores::filter_scalar_topology viskores::io MPI::MPI_CXX)
  viskores_add_target_information(ContourTree_Distributed
                              MODIFY_CUDA_FLAGS
                              DEVICE_SOURCES ContourTreeApp.cxx)

  option (VISKORES_EXAMPLE_CONTOURTREE_ENABLE_DEBUG_PRINT Off)
  mark_as_advanced(VISKORES_EXAMPLE_CONTOURTREE_ENABLE_DEBUG_PRINT)
  if (VISKORES_EXAMPLE_CONTOURTREE_ENABLE_DEBUG_PRINT)
    target_compile_definitions(ContourTree_Distributed PRIVATE "DEBUG_PRINT")
    target_compile_definitions(ContourTree_Distributed PRIVATE "DEBUG_PRINT_CTUD")
  endif()

  if (TARGET viskores::tbb)
    target_compile_definitions(ContourTree_Distributed PRIVATE "ENABLE_SET_NUM_THREADS")
  endif()
  if (Viskores_ENABLE_HDF5_IO)
    if(Viskores_HDF5_IS_PARALLEL)
      target_compile_definitions(ContourTree_Distributed PRIVATE "ENABLE_HDFIO")
      target_include_directories(ContourTree_Distributed PRIVATE ${HDF5_INCLUDE_DIR})
      target_link_libraries(ContourTree_Distributed ${HDF5_LIBRARIES})
    else()
      message(FATAL_ERROR "Compiling distributed contour tree example with HDF5 support requires using a parallel HDF5 library and enabling Viskores_HDF5_IS_PARALLEL")
    endif()
  endif ()

  add_executable(TreeCompiler TreeCompilerApp.cxx)
  target_link_libraries(TreeCompiler viskores::filter_core)
  viskores_add_target_information(TreeCompiler DROP_UNUSED_SYMBOLS MODIFY_CUDA_FLAGS DEVICE_SOURCES TreeCompilerApp.cxx)

  add_executable(BranchCompiler BranchCompilerApp.cxx)
  target_link_libraries(BranchCompiler viskores::filter_scalar_topology)
  viskores_add_target_information(BranchCompiler DROP_UNUSED_SYMBOLS MODIFY_CUDA_FLAGS DEVICE_SOURCES BranchCompilerApp.cxx)

  configure_file(split_data_2d.py split_data_2d.py COPYONLY)
  configure_file(split_data_3d.py split_data_3d.py COPYONLY)
  configure_file(hact_test.sh hact_test.sh COPYONLY)
  configure_file(hact_test_volume.sh hact_test_volume.sh COPYONLY)
  configure_file(hact_test_branch_decomposition.sh hact_test_branch_decomposition.sh COPYONLY)
  configure_file(testrun_branch_decomposition.sh testrun_branch_decomposition.sh COPYONLY)
  configure_file(testrun.sh testrun.sh COPYONLY)
  configure_file(testrun_volume.sh testrun_volume.sh COPYONLY)
endif()

=== examples/cosmotools/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(CosmoTools CXX)

#Find the Viskores package
find_package(Viskores REQUIRED QUIET)

add_executable(CosmoCenterFinder CosmoCenterFinder.cxx)
add_executable(CosmoHaloFinder CosmoHaloFinder.cxx)
target_link_libraries(CosmoCenterFinder PRIVATE viskores::filter_core)
target_link_libraries(CosmoHaloFinder PRIVATE viskores::filter_core)

viskores_add_target_information(CosmoCenterFinder CosmoHaloFinder
                            DROP_UNUSED_SYMBOLS
                            MODIFY_CUDA_FLAGS
                            DEVICE_SOURCES
                              CosmoCenterFinder.cxx CosmoHaloFinder.cxx)

=== examples/demo/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(ViskoresDemo CXX)

#Find the Viskores package
find_package(Viskores REQUIRED QUIET)

if(TARGET viskores::rendering AND TARGET viskores::filter_contour AND TARGET viskores::source)
  add_executable(Demo Demo.cxx)
  target_link_libraries(Demo PRIVATE viskores::rendering viskores::filter_contour viskores::source)
endif()

=== examples/game_of_life/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(GameOfLife CXX)

#Find the Viskores package
find_package(Viskores REQUIRED QUIET)
viskores_find_gl(OPTIONAL GL GLUT GLEW)

if(TARGET OpenGL::GL AND
   TARGET GLUT::GLUT AND
   TARGET GLEW::GLEW)

  add_executable(GameOfLife GameOfLife.cxx LoadShaders.h)
  target_link_libraries(GameOfLife PRIVATE viskores::filter_core OpenGL::GL GLEW::GLEW GLUT::GLUT)
  viskores_add_target_information(GameOfLife
                              DROP_UNUSED_SYMBOLS MODIFY_CUDA_FLAGS
                              DEVICE_SOURCES GameOfLife.cxx)
endif()

=== examples/hello_worklet/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(HelloWorklet CXX)

#Find the Viskores package
find_package(Viskores REQUIRED QUIET)

if(TARGET viskores::io)
  add_executable(HelloWorklet HelloWorklet.cxx)
  target_link_libraries(HelloWorklet PRIVATE viskores::filter_core viskores::io)

  viskores_add_target_information(HelloWorklet
    DROP_UNUSED_SYMBOLS
    MODIFY_CUDA_FLAGS
    DEVICE_SOURCES HelloWorklet.cxx)
endif()

=== examples/lagrangian/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)

#Find the Viskores package
find_package(Viskores REQUIRED QUIET)

if(TARGET viskores::filter_flow)
  add_executable(Lagrangian lagrangian.cxx ABCfield.h)
  target_link_libraries(Lagrangian PRIVATE viskores::filter_flow)
endif()

=== examples/lagrangian_structures/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##=============================================================================
##
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##
##=============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(ParticleAdvection CXX)

#Find the Viskores package
find_package(Viskores REQUIRED QUIET)

add_executable(ftle LagrangianStructures.cxx)
target_link_libraries(ftle PRIVATE viskores::cont viskores::worklet)
viskores_add_target_information(ftle
                            DROP_UNUSED_SYMBOLS MODIFY_CUDA_FLAGS
                            DEVICE_SOURCES  LagrangianStructures.cxx)
if(TARGET viskores::tbb)
  target_compile_definitions(ftle PRIVATE BUILDING_TBB_VERSION)
endif()

=== examples/multi_backend/CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(MultiBackend CXX)

#Find the Viskores package
find_package(Viskores REQUIRED)
find_package(Threads REQUIRED QUIET)

set(headers
  IOGenerator.h
  MultiDeviceGradient.h
  TaskQueue.h
  )

set(srcs
  MultiBackend.cxx
  MultiDeviceGradient.cxx
  IOGenerator.cxx
  )

if(TARGET viskores::filter_vector_analysis)
  add_executable(MultiBackend ${srcs} ${headers})
  target_link_libraries(MultiBackend PRIVATE viskores::filter_vector_analysis Threads::Threads)
  viskores_add_target_information(MultiBackend
    DROP_UNUSED_SYMBOLS
    MODIFY_CUDA_FLAGS
    DEVICE_SOURCES ${srcs})
endif()

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=viskores
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.0.0
pkgrel=3
pkgdesc="A visualization library for many-threaded devices. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://github.com/Viskores/viskores'
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-tbb")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             #"${MINGW_PACKAGE_PREFIX}-anari-sdk"
             "${MINGW_PACKAGE_PREFIX}-glew")
#optdepends=("${MINGW_PACKAGE_PREFIX}-anari-sdk")
source=("https://github.com/Viskores/viskores/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('5bff5bbd747b7662bb4630889960371d06fcc5e5a962d974a898d1883f196eba')

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DViskores_INSTALL_CMAKE_MODULE_DIR=lib/cmake \
      -DViskores_CUSTOM_LIBRARY_SUFFIX="" \
      -DViskores_ENABLE_DEVELOPER_FLAGS=OFF \
      -DViskores_ENABLE_GL_CONTEXT=ON \
      -DViskores_ENABLE_ANARI=OFF \
      -DViskores_ENABLE_HDF5_IO=ON \
      -DViskores_ENABLE_OPENMP=ON \
      -DViskores_ENABLE_TBB=ON \
      -DViskores_ENABLE_TESTING=OFF \
      -DViskores_USE_DEFAULT_TYPES_FOR_VTK=ON \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  # Fix CMake config file
  BUILD_DIR=$(cygpath -m "${srcdir}/build-${MSYSTEM}")
  sed -e "s|${BUILD_DIR}|"A:/_"|g" \
    -i "${pkgdir}"${MINGW_PREFIX}/lib/cmake/viskores-${pkgver%.*}/ViskoresConfig.cmake
}
